diff --git a/README.md b/README.md
index 10e40e864de03743574782d9b7ff062cb16957ec..3ec123513f29399c2e18b0fc69ff76c5abcc386b 100644
--- a/README.md
+++ b/README.md
@@ -4,3 +4,4 @@
* Expose git information with Spring Boot’s Actuator ([Blog](https://rieckpil.de/howto-expose-git-information-with-spring-boots-actuator/), [Sources](https://github.com/rieckpil/blog-tutorials/tree/master/expose-git-information-actuator))
* Write Spring Boot integration tests with a ‘real’ database ([Blog](https://rieckpil.de/howto-write-spring-boot-integration-tests-with-a-real-database/), [Sources](https://github.com/rieckpil/blog-tutorials/tree/master/testcontainers))
+* Avoid repeating attributes in JPA entities ([Blog](https://rieckpil.de/howto-avoid-repeating-attributes-in-jpa-entities/), [Sources](https://github.com/rieckpil/blog-tutorials/tree/master/avoid-repeating-attributes-in-jpa-entites))
diff --git a/avoid-repeating-attributes-in-jpa-entities/.gitignore b/avoid-repeating-attributes-in-jpa-entities/.gitignore
new file mode 100644
index 0000000000000000000000000000000000000000..82eca336e352c9026decda294ff678968050edfc
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/.gitignore
@@ -0,0 +1,25 @@
+/target/
+!.mvn/wrapper/maven-wrapper.jar
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/build/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
\ No newline at end of file
diff --git a/avoid-repeating-attributes-in-jpa-entities/.mvn/wrapper/maven-wrapper.jar b/avoid-repeating-attributes-in-jpa-entities/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000000000000000000000000000000000000..9cc84ea9b4d95453115d0c26488d6a78694e0bc6
Binary files /dev/null and b/avoid-repeating-attributes-in-jpa-entities/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/avoid-repeating-attributes-in-jpa-entities/.mvn/wrapper/maven-wrapper.properties b/avoid-repeating-attributes-in-jpa-entities/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000000000000000000000000000000000000..b573bb50d56e8c19282593cbf5b081e211923a83
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1 @@
+distributionUrl=https://repo1.maven.org/maven2/org/apache/maven/apache-maven/3.5.3/apache-maven-3.5.3-bin.zip
diff --git a/avoid-repeating-attributes-in-jpa-entities/README.md b/avoid-repeating-attributes-in-jpa-entities/README.md
new file mode 100644
index 0000000000000000000000000000000000000000..36a2c6293186424c69f240ef7c12b1ee9bb42857
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/README.md
@@ -0,0 +1,8 @@
+# Codebase for the blog post [#HOWTO: Avoid repeating attributes in JPA entities](https://rieckpil.de/howto-avoid-repeating-attributes-in-jpa-entities/)
+
+Steps to run this project:
+
+1. Clone this Git repository
+2. Navigate to the folder `avoid-repeating-attributes-in-jpa-entities`
+3. Run this project with `mvn spring-boot:run`
+4. Visit the H2 console at `http://localhost:8080`
\ No newline at end of file
diff --git a/avoid-repeating-attributes-in-jpa-entities/mvnw b/avoid-repeating-attributes-in-jpa-entities/mvnw
new file mode 100755
index 0000000000000000000000000000000000000000..5bf251c0774593ca4f5335acf0f7483eaa162e8f
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/mvnw
@@ -0,0 +1,225 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven2 Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Migwn, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+ # TODO classpath?
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`which java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+echo $MAVEN_PROJECTBASEDIR
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/avoid-repeating-attributes-in-jpa-entities/mvnw.cmd b/avoid-repeating-attributes-in-jpa-entities/mvnw.cmd
new file mode 100644
index 0000000000000000000000000000000000000000..019bd74d766ebd4c033528112148d866555b5c9e
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/mvnw.cmd
@@ -0,0 +1,143 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM http://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven2 Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a key stroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM enable echoing my setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%
diff --git a/avoid-repeating-attributes-in-jpa-entities/pom.xml b/avoid-repeating-attributes-in-jpa-entities/pom.xml
new file mode 100644
index 0000000000000000000000000000000000000000..2ab0f3eecd9685d6491686d6239c259fea24a605
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/pom.xml
@@ -0,0 +1,64 @@
+
+
+ 4.0.0
+
+ de.blog.rieckpil
+ avoid-repeating-attributes-in-jpa-entities
+ 0.0.1-SNAPSHOT
+ jar
+
+ avoid-repeating-attributes-in-jpa-entities
+ Demo project fo avoiding repeated attributes in JPA entities
+
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.0.3.RELEASE
+
+
+
+
+ UTF-8
+ UTF-8
+ 1.8
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-data-jpa
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+
+ com.h2database
+ h2
+ runtime
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
+
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/AvoidRepeatingAttributesInJpaEntitiesApplication.java b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/AvoidRepeatingAttributesInJpaEntitiesApplication.java
new file mode 100644
index 0000000000000000000000000000000000000000..bb29cf6b9c9e25d4d450feac4a6eb35735d3f243
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/AvoidRepeatingAttributesInJpaEntitiesApplication.java
@@ -0,0 +1,12 @@
+package de.blog.rieckpil.avoidrepeatingattributesinjpaentities;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class AvoidRepeatingAttributesInJpaEntitiesApplication {
+
+ public static void main(String[] args) {
+ SpringApplication.run(AvoidRepeatingAttributesInJpaEntitiesApplication.class, args);
+ }
+}
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/BaseEnterpriseEntity.java b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/BaseEnterpriseEntity.java
new file mode 100644
index 0000000000000000000000000000000000000000..ccb759ef20c0c4fae3a2a598e78246435f61be6f
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/BaseEnterpriseEntity.java
@@ -0,0 +1,32 @@
+package de.blog.rieckpil.avoidrepeatingattributesinjpaentities;
+
+import lombok.Data;
+import org.hibernate.annotations.CreationTimestamp;
+import org.hibernate.annotations.UpdateTimestamp;
+
+import javax.persistence.*;
+import java.time.LocalDateTime;
+import java.util.concurrent.ThreadLocalRandom;
+
+@Data
+@MappedSuperclass
+public class BaseEnterpriseEntity {
+
+ @Id
+ @GeneratedValue(strategy = GenerationType.IDENTITY)
+ private Long id;
+
+ private String internId;
+
+ @CreationTimestamp
+ private LocalDateTime createdAt;
+
+ @UpdateTimestamp
+ private LocalDateTime updatedAt;
+
+ @PrePersist
+ public void prePersist() {
+ this.internId = String.valueOf(Math.abs(ThreadLocalRandom.current().nextInt()));
+ }
+
+}
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/Customer.java b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/Customer.java
new file mode 100644
index 0000000000000000000000000000000000000000..c238ae047197fc171f79aee58e57db1e24680034
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/Customer.java
@@ -0,0 +1,18 @@
+package de.blog.rieckpil.avoidrepeatingattributesinjpaentities;
+
+import lombok.Data;
+
+import javax.persistence.Column;
+import javax.persistence.Entity;
+
+@Data
+@Entity
+public class Customer extends BaseEnterpriseEntity {
+
+ @Column(nullable = false, length = 100)
+ private String name;
+
+ @Column(nullable = false, length = 40)
+ private String customerId;
+
+}
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/CustomerRepository.java b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/CustomerRepository.java
new file mode 100644
index 0000000000000000000000000000000000000000..ab14385a49a0b5e4dc7275d0a90d7e44264afd6a
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/CustomerRepository.java
@@ -0,0 +1,6 @@
+package de.blog.rieckpil.avoidrepeatingattributesinjpaentities;
+
+import org.springframework.data.jpa.repository.JpaRepository;
+
+public interface CustomerRepository extends JpaRepository {
+}
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/DatabaseFiller.java b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/DatabaseFiller.java
new file mode 100644
index 0000000000000000000000000000000000000000..6fee2392772f2289c269ab441de2374b283b41b5
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/DatabaseFiller.java
@@ -0,0 +1,31 @@
+package de.blog.rieckpil.avoidrepeatingattributesinjpaentities;
+
+import org.springframework.boot.CommandLineRunner;
+import org.springframework.stereotype.Component;
+
+@Component
+public class DatabaseFiller implements CommandLineRunner {
+
+ private final CustomerRepository customerRepository;
+ private final ProductRepository productRepository;
+
+ public DatabaseFiller(CustomerRepository customerRepository, ProductRepository productRepository) {
+ this.customerRepository = customerRepository;
+ this.productRepository = productRepository;
+ }
+
+ @Override
+ public void run(String... args) throws Exception {
+
+ Customer c1 = new Customer();
+ c1.setName("John Doe");
+ c1.setCustomerId("XYZ1337");
+
+ Product p1 = new Product();
+ p1.setAmount(100);
+ p1.setName("Keyboard");
+
+ customerRepository.save(c1);
+ productRepository.save(p1);
+ }
+}
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/Product.java b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/Product.java
new file mode 100644
index 0000000000000000000000000000000000000000..1375674bd261804d291474ee53625c274b70cbf8
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/Product.java
@@ -0,0 +1,17 @@
+package de.blog.rieckpil.avoidrepeatingattributesinjpaentities;
+
+import lombok.Data;
+
+import javax.persistence.Column;
+import javax.persistence.Entity;
+
+@Data
+@Entity
+public class Product extends BaseEnterpriseEntity {
+
+ @Column(nullable = false, length = 100)
+ private String name;
+
+ private int amount;
+
+}
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/ProductRepository.java b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/ProductRepository.java
new file mode 100644
index 0000000000000000000000000000000000000000..c921d4e1640a7d1f55134e765405b75f90434bef
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/main/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/ProductRepository.java
@@ -0,0 +1,6 @@
+package de.blog.rieckpil.avoidrepeatingattributesinjpaentities;
+
+import org.springframework.data.jpa.repository.JpaRepository;
+
+public interface ProductRepository extends JpaRepository {
+}
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/main/resources/application.properties b/avoid-repeating-attributes-in-jpa-entities/src/main/resources/application.properties
new file mode 100644
index 0000000000000000000000000000000000000000..69b89983cb2b54a75be402a7d8ff5f4c9cd4c069
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/main/resources/application.properties
@@ -0,0 +1 @@
+spring.h2.console.enabled=true
\ No newline at end of file
diff --git a/avoid-repeating-attributes-in-jpa-entities/src/test/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/AvoidRepeatingAttributesInJpaEntitiesApplicationTests.java b/avoid-repeating-attributes-in-jpa-entities/src/test/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/AvoidRepeatingAttributesInJpaEntitiesApplicationTests.java
new file mode 100644
index 0000000000000000000000000000000000000000..8d441cae8470a2f6329038d285dc07b7781ffd54
--- /dev/null
+++ b/avoid-repeating-attributes-in-jpa-entities/src/test/java/de/blog/rieckpil/avoidrepeatingattributesinjpaentities/AvoidRepeatingAttributesInJpaEntitiesApplicationTests.java
@@ -0,0 +1,16 @@
+package de.blog.rieckpil.avoidrepeatingattributesinjpaentities;
+
+import org.junit.Test;
+import org.junit.runner.RunWith;
+import org.springframework.boot.test.context.SpringBootTest;
+import org.springframework.test.context.junit4.SpringRunner;
+
+@RunWith(SpringRunner.class)
+@SpringBootTest
+public class AvoidRepeatingAttributesInJpaEntitiesApplicationTests {
+
+ @Test
+ public void contextLoads() {
+ }
+
+}